<template>
    <div class="service-container" v-if="state.issuePage == 1">
        <div
            class="
                offset-9
                col-lg-2 col-md-3 col-xs-6
                q-mr-md-lg q-mr-xs-sm
                row
                justify-end
            "
        >
            <q-btn
                no-caps
                text-color="white"
                :label="$t('button.createIssue')"
                @click="state.issuePage = 2"
                class="button-save"
            />
        </div>
        <div class="col-12 border-radius-20 service q-pa-md scroll">
            <vue-data-table
                :headers="issuesType"
                :data="issueData(state.issueList)"
                :actions="issueTypeAction"
                :remove="issueTypeAction2"
                :editIssueType="editIssueType"
                :removeIssueType="removeIssueType"
            />
        </div>
    </div>
    <div class="service-container" v-else-if="state.issuePage == 2">
        <create-issue @update-issuePage="updateIssuePage" />
    </div>
    <div class="service-container" v-else-if="state.issuePage == 3">
        <update-issue 
            :issue="state.currentIssueType"
            @update-issuePage="updateIssuePage"
        />
    </div>
</template>
<script lang="ts">
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-explicit-any*/
/* eslint-disable @typescript-eslint/no-floating-promises */
import { useStore } from 'src/store';
import { useI18n } from 'vue-i18n';
import { defineComponent, computed, watch, reactive, onMounted } from 'vue';
import VueDataTable from 'src/components/datatable/VueDataTable.vue';
import CreateIssue from 'src/components/issuesType/CreateIssue.vue';
import UpdateIssue from 'src/components/issuesType/UpdateIssue.vue';

export default defineComponent({
    name: 'IssuesList',
    components: {
        VueDataTable,
        CreateIssue,
        UpdateIssue
    },
    setup() {
        const store = useStore();
        const { t } = useI18n();
        const lang = store.state.user.user?.locale;

        const selectedBusinessId = computed(() => {
            return store.state.business.businessID;
        });

        const updateIssuePage = (value: any) => {
            state.issuePage = value;
        };

        let state = reactive({
            issueList: computed(() => {
                return store.state.issueType.issueTypes;
            }),
            issueTypeList: [] as any,
            issuePage: 1,
            currentIssueType: {} as any,
            issueTypeId: ''
        });

        const issueTypeAction = ['editIssue'];
        const issueTypeAction2 = ['removeIssue'];

        //Service Table Header
        const issuesType = [
            t('preference.issueName', {}, { locale: lang }),
            t('preference.orderNumber', {}, { locale: lang }),
            t('preference.issueFlag', {}, { locale: lang }),
            t('tables.actions', {}, { locale: lang })
        ];

        //watch
        watch(selectedBusinessId, () => {
            if (selectedBusinessId.value) {
                getIssueType();
            }
        });

        const getIssueType = async () => {
            const res = await store.dispatch('issueType/getIssueTypeByBusinessID', {
                businessId: selectedBusinessId.value,
                isHiddenIncluded: true
            });
            if (res) {
                res.issueTypes.findIndex((element: any) => {
                    state.issueTypeId = element.id
                }) 
            }
        };

        const editIssueType = (data: any) => {
            if (data) {
                const findIndex = state.issueList.findIndex(
                    (element: any) => element.name == data.name
                );
                if (findIndex != -1) {
                    state.currentIssueType = state.issueList[findIndex];
                    state.issuePage = 3;
                }
            }
        };

        const removeIssueType = async () => {
            await store.dispatch('issueType/deleteIssuesType', {
                issueTypeId: state.issueTypeId
            });
        };
        
        const issueData = (data: any) => {
            let resultsList: any = [];

            data.forEach((element: any) => {
                let issue = {
                    name: element.name,
                    orderNo: element.orderNo,
                    flag: element.isHidden
                };
                if (element.isHidden === true) {
                    element.isHidden = 'Internal'
                } else if(element.isHidden === false) {
                    element.isHidden = 'Public'
                }
                resultsList.push(issue);
            });
            return resultsList;
        };

        onMounted(getIssueType);

        return {
            state,
            updateIssuePage,
            issuesType,
            issueData,
            issueTypeAction,
            issueTypeAction2,
            editIssueType,
            removeIssueType
        };
    }
});
</script>
